Codeforces 327A Flipping Game(区间DP,暴力枚举)

Flipping Game


Iahub got bored, so he invented a game to be played on paper.
He writes n integers a1, a2, …, an. Each of those integers can be either 0 or 1. He’s allowed to do exactly one move: he chooses two indices i and j (1 ≤ i ≤ j ≤ n) and flips all values ak for which their positions are in range [i, j] (that is i ≤ k ≤ j). Flip the value of x means to apply operation x = 1 - x.
The goal of the game is that after exactly one move to obtain the maximum number of ones. Write a program to solve the little game of Iahub.
Input
The first line of the input contains an integer n (1 ≤ n ≤ 100). In the second line of the input there are n integers: a1, a2, …, an. It is guaranteed that each of those n values is either 0 or 1.
Output
Print an integer — the maximal number of 1s that can be obtained after exactly one move.

Example
Input
5
1 0 0 1 0
Output
4

Input
4
1 0 0 1
Output
4

Note
In the first case, flip the segment from 2 to 5 (i = 2, j = 5). That flip changes the sequence, it becomes: [1 1 1 0 1]. So, it contains four ones. There is no way to make the whole sequence equal to [1 1 1 1 1].
In the second case, flipping only the second and the third element (i = 2, j = 3) will turn all numbers into 1


题意

给定一串01序列,选择其中一段翻转,也就是0变1,1变0.求一次翻转后的最多1的数目。

思路

暴力枚举:
用个数组储存前缀和,表示i之前1的数目,在枚举每个区间,数据比较小,也能过。
区间DP:
预处理差不多,DP[i][j]表示I到j之间一次翻转后一最多的数量。
对于每个区间而言,在中间找个断点k,一次翻转可能发生在前面IK,也可能发生在Kj之间,
那我们就得到了状态转移方程
dp[I][j]=max(dp[i][k]+sum[j]-sum[k],dp[k+1][j]+sum[k]-sum[i-1]));
(i<=K < j)

#include<iostream>
#include<cstdio>
#include<algorithm>
#include<math.h>
#include<string.h>
#define mem(a,b)  memset((a),(b),sizeof(b));
using namespace std;


int main()
{
    ios::sync_with_stdio(false);
   // freopen("text.txt", "r", stdin);
    int a[105];
    int sum[105];
    int dp[105][105];
    int n;
    cin>>n;
    sum[0]=0;
    memset(dp,0,sizeof(dp));
    for(int i=1;i<=n;i++)
        {
            cin>>a[i];
            sum[i]=a[i]+sum[i-1];
            dp[i][i]=1-a[i];
        }

    for(int l=1;l<n;l++)
        for(int i=1;i+l<=n;i++)
    {
        int j=i+l;
        dp[i][j]=j-i+1-sum[j]+sum[i-1];
        for(int k=i;k<j;k++)
            dp[i][j]=max(dp[i][j],
                    max(dp[i][k]+sum[j]-sum[k],
                    dp[k+1][j]+sum[k]-sum[i-1]));
                    //cout<<i<<' '<<j<<' '<<dp[i][j]<<endl;
    }

    cout<<dp[1][n]<<endl;
    return 0;
}

所谓水题就是拿来练习,只有对某种方法足够熟练,有一定理解才能用起来得心应手,虽然我现在菜的不行,但坚持下去,我想会有收获的。

  • 1
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
区间DP是一种动态规划的方法,用于解决区间范围内的问题。在Codeforces竞赛中,区间DP经常被用于解决一些复杂的字符串或序列相关的问题。 在区间DP中,dp[i][j]表示第一个序列前i个元素和第二个序列前j个元素的最优解。具体的转移方程会根据具体的问题而变化,但是通常会涉及到比较两个序列的元素是否相等,然后根据不同的情况进行状态转移。 对于区间长度为1的情况,可以先进行初始化,然后再通过枚举区间长度和区间左端点,计算出dp[i][j]的值。 以下是一个示例代码,展示了如何使用区间DP来解决一个字符串匹配的问题: #include <cstdio> #include <cstring> #include <string> #include <iostream> #include <algorithm> using namespace std; const int maxn=510; const int inf=0x3f3f3f3f; int n,dp[maxn][maxn]; char s[maxn]; int main() { scanf("%d", &n); scanf("%s", s + 1); for(int i = 1; i <= n; i++) dp[i][i] = 1; for(int i = 1; i <= n; i++) { if(s[i] == s[i - 1]) dp[i][i - 1] = 1; else dp[i][i - 1] = 2; } for(int len = 3; len <= n; len++) { int r; for(int l = 1; l + len - 1 <= n; l++) { r = l + len - 1; dp[l][r] = inf; if(s[l] == s[r]) dp[l][r] = min(dp[l + 1][r], dp[l][r - 1]); else { for(int k = l; k <= r; k++) { dp[l][r] = min(dp[l][r], dp[l][k] + dp[k + 1][r]); } } } } printf("%d\n", dp[n]); return 0; } 希望这个例子能帮助你理解区间DP的基本思想和应用方法。如果你还有其他问题,请随时提问。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值